#include <stdio.h>
#include <string.h>

#include "diagnostics.h"
#include "ycht_pkt.h"

/* Displays a tcpdump/snort style packet dump */
void DumpYCHTPkt(unsigned char * pkt)
{
	int row,col,totrows,x;
	unsigned char ch;

	totrows=(pktTotalLen(pkt)/16);
	if(pktTotalLen(pkt)%16) totrows++;
	printf("\n");
	for(row=0;row<totrows;row++)
	{
		for(col=0;col<16;col++)
		{
			ch=pkt[(row*16)+col];
			if(ch <= 0xF) printf("0");

			/* it's an incomplete col, don't print it all and move the cursor to where the ascii starts */
			if((row*16)+col == pktTotalLen(pkt))
			{
				for(x=col;x<16;x++) printf("   ");
				break;
			}
			printf("%x ",pkt[(row*16)+col]);
		}

		for(col=0;col<16;col++)
		{
			ch=pkt[(row*16)+col];
			if(ch > 0x7F || ch < 0x20) ch='.';

			/* it's an incomplete col, don't print it all */
			if((row*16)+col == pktTotalLen(pkt)) break;
			printf("%c",ch);
		}
		printf("\n");
	}
}
